#include "cll1.h"

/* This is C<<1 rewrite of object polymorphism from
   http://en.wikipedia.org/wiki/Polymorphism_in_object-oriented_programming
   
   Of course there are easier ways to do the same thing... :-) 
   (G)2008 xChas */

def_type(Animal);

def_mem(Actions)
{
 str method(talk) (Animal self);
};

def_obj(Animal)
{
 interface(Actions);
 char *name;
};

construct(Animal,Actions) (Animal self, str name)
{
 self->name = name;
 return self;
}

/* implementation of methods */

str catTalk(Animal self)
{
 return "Meow!";
}

str dogTalk(Animal self)
{
 return "Arf! Arf!";
}

/* registration of methods to object interface */

Actions catActions(void)
{
 Get_mem(this, Actions);

 this->talk = catTalk;
 return this;
}

Actions dogActions(void)
{
 Get_mem(this, Actions);

 this->talk = dogTalk;
 return this;
}

/* usage of objects inside C<<1 program */

program
{
 int i;
 Animal animal[3];
 Actions cat = catActions();
 Actions dog = dogActions();

 animal[0] = get_obj(Animal, cat, "Missy");
 animal[1] = get_obj(Animal, cat, "Mr. Bojangles");
 animal[2] = get_obj(Animal, dog, "Lassie");

 for_range(i, 0, 2)
 {
  print(animal[i]->name, ":", _(talk, animal[i]));
 }

}
